#!/usr/bin/perl
#$cgi_path = "/path/to/cgi-bin";

if($cgi_path eq '') {
  $cgi_path = `pwd`;
  $cgi_path =~ s/[[:space:]\r\n]//g;
  if($cgi_path eq '') {
    $cgi_path = `cd`;
    $cgi_path =~ s/[[:space:]\r\n]//g;
    if($cgi_path eq '') {
      print "Content-Type: text/html\n\n";
      print "<center>\n";
      print "You need to set \$cgi_path on line 2 of this script<BR>\n";
      print "</center>\n";
      exit;
    }
  }
}

require "$cgi_path/functions.pl";
if(-e "$cgi_path/data/options.pl") {
  require "$cgi_path/data/options.pl";
} else {
  err('Please use setup.cgi to configure pStats', 1);
}

#################
#  Script Body  #
#################

print "Content-Type: text/html\n\n";
if($ENV{'REQUEST_METHOD'} eq "POST") {
  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs)
  {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/~!/ ~!/g;
      $FORM{$name} .= (defined $FORM{$name}) ? "," . $value : $value;
  }
  if(&check_pass) {
    if(!$FORM{'action'}) {
      err('No action selected.');
    } else {
      $VAR{'apw'} = $FORM{'apw'};
      *action = $FORM{'action'};
      &action;
    }
  } else {
    err('Invalid Password.');
  }
} else {
  &display_login;
}
exit;

sub check_pass {
  open(PWD, "$cgi_path/data/admin.pws") || err("Could not open password file.");
  $pass = <PWD>;
  close(PWD);
  chomp($pass);
  return $pass eq crypt($FORM{'apw'}, "ps");
}

sub display_login {
  fparse('_admin_login.htmlt');
}

sub display_main {
  $VAR{'MSG'} = shift;
  fparse('_admin_main.htmlt');
}

sub member_action {
  if(!$FORM{'member_action'}) {
    err("No member action selected");
  } else {
    *maction = $FORM{'member_action'};
    &maction;
  }
}

sub display_all_members {
  $FORM{'id'} = ".*?";
  &display_members;
}

sub display_members {
  $FORM{'id'} = ".*?" if ($FORM{'id'} eq '');
  fparse('_admin_members_display_top.htmlt');
  opendir(DIR, "$cgi_path/data/members");
  @members = grep { /$FORM{'id'}\.dat/ } readdir(DIR);
  close(DIR);
  foreach (sort @members) {
     open(MEMBER, "$cgi_path/data/members/$_");
     @mem = <MEMBER>;
     close(MEMBER);
     foreach(@mem) { chomp; }
     $VAR{'NAME'} = $mem[0];
     $VAR{'USER'} = getmem($_);
     $VAR{'EMAIL'} = $mem[2];
     $VAR{'SITE'} = $mem[3];
     @time = localtime($mem[5]);
     $time[5] += 1900;
     $time[4] += 1;
     $VAR{'JOINED'} = "$time[4]-$time[3]-$time[5]";
     if($mem[4] > 0) {
       $VAR{'PRIV'} = "Yes";
     } else {
       $VAR{'PRIV'} = "No";
     }
     fparse('_admin_members_display_row.htmlt');
  }
  fparse('_admin_members_display_bottom.htmlt');
}

sub edit_member {
  if(!defined $FORM{'id'}) {
    display_main("No member selected.");
  } else {
    $FORM{'id'} =~ s/,.*//g;
    if(! -e "$cgi_path/data/members/$FORM{'id'}.dat") {
      display_main("$FORM{'id'}: username does not exist.");
      exit;
    }
    if($FORM{'step'} == 2) {
      open(MEMBER, "$cgi_path/data/members/$FORM{'id'}.dat") || err("Could not open member file.");
      @mem = <MEMBER>;
      close(MEMBER);
      foreach(@mem) { chomp $_; }
      if($FORM{'pass'} ne '') {
        $mem[1] = crypt($FORM{'pass'}, "ps");
      }
      $mem[2] = $FORM{'email'};
      $mem[3] = $FORM{'site'};
      if(defined $FORM{'private'}) {
        $mem[4] = 1;
      } else {
        $mem[4] = 0;
      }
      open(MEMBER, ">$cgi_path/data/members/$FORM{'id'}.dat") || err("Could not open member file for writing.");
      print MEMBER join("\n", @mem);
      close(MEMBER);
      display_main("$FORM{'id'} updated successfully!");
    } else {
      open(MEMBER, "$cgi_path/data/members/$FORM{'id'}.dat");
      @mem = <MEMBER>;
      close(MEMBER);
      $VAR{'NAME'} = $mem[0];
      $VAR{'USER'} = $FORM{'id'};
      $VAR{'EMAIL'} = $mem[2];
      $VAR{'SITE'} = $mem[3];
      if($mem[4] > 0) {
        $VAR{'PRIV'} = "CHECKED";
      }
      fparse('_admin_members_edit.htmlt');
    }
  }
}

sub delete_members {
  if(!defined $FORM{'id'}) {
    display_main("No member selected.");
  } else {
    if($FORM{'step'} == 2) {
      foreach(split(/,/, $FORM{'id'})) {
        unlink("$cgi_path/data/members/$_.dat");
        unlink <$cgi_path/data/members/$_/*>;
        rmdir("$cgi_path/data/members/$_");
      }
      display_main("$FORM{'id'} deleted successfully.");
    } else {
    fparse('_admin_members_delete_top.htmlt');
    foreach(split(/,/, $FORM{'id'})) {
      $VAR{'USER'} = $_;
      fparse('_admin_members_delete_row.htmlt');
    }
    fparse('_admin_members_delete_bottom.htmlt');
    }
  }
}

sub create_account {
  if ($FORM{'step'} == 2) {
    if($FORM{'name'} eq '') { create_account_err("please enter your name"); }
    if($FORM{'user'} eq '') { create_account_err("please enter a username"); }
    if($FORM{'email'} eq '') { create_account_err("please enter your email address"); }
    if($FORM{'site'} eq '') { create_account_err("please enter your sites url"); }
    if($FORM{'pass'} eq '') { create_account_err("please enter a password"); }
    if($FORM{'vpass'} eq '') { create_account_err("please verify your password"); }
    if(-e "$cgi_path/data/members/$FORM{'user'}.dat") {
      $user = $FORM{'user'};
      $FORM{'user'} = '';
      create_account_err("$user already exists.");
    } else {
      if($FORM{'pass'} eq $FORM{'vpass'}) {
        if(defined $FORM{'private'}) {
          $private = 1;
        } 
        $password = crypt($FORM{'pass'}, "ps");
        $time = time;
        open(MEM, ">$cgi_path/data/members/$FORM{'user'}.dat") || ShowErr("Could not open member file for writing");
        print MEM "$FORM{'name'}\n$password\n$FORM{'email'}\n$FORM{'site'}\n$private\n$time";
        close(MEM);
        mkdir("$cgi_path/data/members/$FORM{'user'}", 0777) || ShowErr("Could not create data directory.");
      } else {
        create_account_err("Passwords do not match.");
      }
    }
    $VAR{'URL'} = "$OPTION{'cgi_url'}stats.cgi?id=$FORM{'user'}";
    display_main("$FORM{'user'} created successfully.");
  } else {
    fparse('_admin_member_create.htmlt');
  } 
}
sub create_account_err {
  $VAR{'MSG'}     = shift;
  $VAR{'user'}    = $FORM{'user'};
  $VAR{'email'}   = $FORM{'email'};
  $VAR{'pass'}    = $FORM{'pass'};
  $VAR{'vpass'}   = $FORM{'vpass'};
  $VAR{'private'} = $FORM{'private'};
  fparse('_admin_member_create.htmlt');
  exit;
}

sub email_members {
  if(!defined $FORM{'id'}) {
    display_main("No member selected.");
    exit;
  }
  if($FORM{'id'} eq '') {
    $FORM{'id'} = "ALL MEMBERS";
  }
  if($FORM{'step'} == 2) {
    if($FORM{'id'} eq "ALL MEMBERS") {
      opendir(DIR, "$cgi_path/data/members");
      @members = grep { /.*?\.dat/ } readdir(DIR);
      close(DIR);
      foreach(@members) {
        $mem = getmem($_);
        if($FORM{'id'} eq "ALL MEMBERS") {
          $FORM{'id'} = $mem;
        } else {
          $FORM{'id'} .= ",$mem";
        }
      }
    }
    foreach(split(/,/, $FORM{'id'})) {
      open(MEMBER, "$cgi_dir/data/members/$_.dat");
      @mem = <MEMBER>;
      close(MEMBER);
      chomp($mem[2]);
      open(MAIL, "|$OPTION{'sendmail'} -t") || err('Could not open mail proram.');
      print MAIL "From: $OPTION{'admin_email'}\n";
      print MAIL "To: $mem[2]\n";
      print MAIL "Subject: $FORM{'subject'}\n\n";
      print MAIL $FORM{'message'};
      close(MAIL);
    }
    display_main("E-mail sent to members.");
  } else {
    $VAR{'id'} = $FORM{'id'};
    fparse('_admin_members_email.htmlt');
  }
}

sub change_password {
  if($FORM{'step'} == 2) {
    if($FORM{'pass'} eq $FORM{'vpass'}) {
      $pass = crypt($FORM{'pass'}, "ps");
      open(APW, ">$cgi_path/data/admin.pws") || err("Could not change admin password.");
      print APW $pass;
      close(APW);
      $VAR{'apw'} = $FORM{'pass'};
      display_main("Password Changed.");
    } else {
      err("Passwords do not match");
    }
  } else {
    fparse('_admin_change_password.htmlt');
    exit;
  }
}

sub delete_stats {
  ($sm, $sd, $sy) = split(/-/, $FORM{'esd'});
  ($em, $ed, $ey) = split(/-/, $FORM{'eed'});
  if($sm eq '' || $sd eq '' || $sy eq '') {
    err("You have entered an invalid starting date!");
  }
  if($em eq '' || $ed eq '' || $ey eq '') {
    err("You have entered an invalid ending date!");
  }
  $start = "$sm-$sd-$sy";
  $end   = GetNextDate("$em-$ed-$ey");
  while($start ne $end) {
    unlink("$cgi_path/data/members/$FORM{'id'}/$start.dat");
    $start = GetNextDate($start);
    
  }
  display_main("Deleted stats for $FORM{'id'}");
}

